commit 3858878623272c18ad8b4d3f856c3a3dbe22577c
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Thu Oct 30 09:42:01 2025 +0000

    Fix taint status for dbm lookups.  Bug 3169
    
    Broken-by: c66a6edf7ba8

diff --git a/src/src/dbfn.c b/src/src/dbfn.c
index 7f6951ee3..30015fe73 100644
--- a/src/src/dbfn.c
+++ b/src/src/dbfn.c
@@ -386,13 +386,15 @@ Arguments:
   key       the key of the record to be read
   klen	    length of key including a terminating NUL (if present)
   length    a pointer to an int into which to return the length, if not NULL
+  hintsdb   TRUE for hints DB use, FALSE for lookup dbm use
 
 Returns: a pointer to the retrieved record, or
          NULL if the record is not found
 */
 
 void *
-dbfn_read_klen(open_db * dbblock, const uschar * key, int klen, int * length)
+dbfn_read_klen(open_db * dbblock, const uschar * key, int klen, int * length,
+  BOOL hintsdb)
 {
 void * yield;
 EXIM_DATUM key_datum, result_datum;
@@ -423,7 +425,7 @@ store the taint status with the data. */
 dlen = exim_datum_size_get(&result_datum);
 DEBUG(D_hints_lookup) debug_printf_indent("dbfn_read: size %u return\n", dlen);
 
-yield = store_get(dlen+1, GET_TAINTED);
+yield = store_get(dlen+1, hintsdb ? GET_TAINTED : GET_UNTAINTED);
 memcpy(yield, exim_datum_data_get(&result_datum), dlen);
 ((uschar *)yield)[dlen] = '\0';
 if (length) *length = dlen;
@@ -451,7 +453,7 @@ Returns: a pointer to the retrieved record, or
 void *
 dbfn_read_with_length(open_db * dbblock, const uschar * key, int * lenp)
 {
-return dbfn_read_klen(dbblock, key, Ustrlen(key)+1, lenp);
+return dbfn_read_klen(dbblock, key, Ustrlen(key)+1, lenp, TRUE);
 }
 
 
diff --git a/src/src/dbfunctions.h b/src/src/dbfunctions.h
index 1b0e446f7..a6fb2b51e 100644
--- a/src/src/dbfunctions.h
+++ b/src/src/dbfunctions.h
@@ -18,7 +18,7 @@ int      dbfn_delete(open_db *, const uschar *);
 open_db *dbfn_open(const uschar *, int, open_db *, BOOL, BOOL);
 open_db * dbfn_open_path(const uschar *, open_db *);
 open_db *dbfn_open_multi(const uschar *, int, open_db *);
-void    *dbfn_read_klen(open_db *, const uschar *, int, int *);
+void    *dbfn_read_klen(open_db *, const uschar *, int, int *, BOOL);
 void    *dbfn_read_with_length(open_db *, const uschar *, int *);
 void    *dbfn_read_enforce_length(open_db *, const uschar *, size_t);
 uschar  *dbfn_scan(open_db *, BOOL, EXIM_CURSOR **);
diff --git a/src/src/lookups/dbmdb.c b/src/src/lookups/dbmdb.c
index d3b26cf0a..58a839e84 100644
--- a/src/src/lookups/dbmdb.c
+++ b/src/src/lookups/dbmdb.c
@@ -91,7 +91,8 @@ dbmdb_find(void * handle, const uschar * filename, const uschar * keystring,
   const uschar * opts)
 {
 open_db * d = (open_db *)handle;
-return (*result = dbfn_read_klen(d, keystring, length+1, NULL)) ? OK : FAIL;
+return (*result = dbfn_read_klen(d, keystring, length+1, NULL, FALSE))
+	? OK : FAIL;
 }
 
 

